#define FORMAT_LITTLEFS_IF_FAILED true

#include <WiFiUdp.h>
#include <NTPClient.h>
//#define GH_INCLUDE_PORTAL  // включить сайт в память программы, ~50кБ (не нужно загружать файлы в память) (для esp)
#define GH_FILE_PORTAL     // включить сайт c flash памяти папка /hub/
//#define GH_NO_MQTT
#include <GyverHub.h>
#include <Stamp.h>
#include <FSManager.h>
#include <SimplePortal.h>
//My
#include "macros.h"            //Список макросов
#include "_user.h"             //Пользовательские настройки
#include "define.h"            //Переменные
#ifdef WS2812_PIN
#include <FastLED.h>
#endif

void setup() {
#ifdef DEBUG_SERIAL_GT
  Serial.begin(115200);
#endif

#ifdef ESP8266
  SPIFFS.begin(); // подключаем файловую систему 
#endif
#ifdef ESP32
  SPIFFS.begin(FORMAT_LITTLEFS_IF_FAILED); // подключаем файловую систему 
#endif
  delay(500);
  SPIFFS.mkdir("/var");
// Инициализация модулей
  module_setup();

  Connect_WiFi_Portal();    // ищем сеть WiFi

  timeClient.begin();
  delay(500);
  timeClient.update(); 
  hour   = timeClient.getHours();
  minute = timeClient.getMinutes();
  #ifndef GH_NO_MQTT
  hub.mqtt.config(MQTT_SERVER, MQTT_PORT, MQTT_USER, MQTT_PASSWORD);
  #endif

  Udp.begin(localPort);
  hub.onBuild(build);     // подключаем билдер
  hub.begin();            // запускаем систему
  FS_LOAD(ip_addr);
  
//----------------------
  Get_Name();
  char arg1[10];
  FOR_i(1,MAX_IP) {
    sprintf_P(arg1, (const char *)F(";%d"), i);
    strcat(str_GHflags_IP, arg1);
  }
 strcat(str_GHflags_IP, "\0");
 DEBUGLN(str_GHflags_IP);
}


void loop() {
  hub.tick();  // обязательно тикаем тут
  // Разные модули
  module_loop();
  // Разные таймеры
  usertimeClientupdate();
  userTimeRead();
  userWiFiReconect();
  userAutoSave();
//  test_alarms();
  Get_Status();
  Get_Name_Evry_10_min();
  parseUDP();
}
